## gbsplay 0.0.91

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,3 @@
-# $Id: Makefile,v 1.98 2006/01/15 00:05:03 ranmachan Exp $
-
 .PHONY: all default distclean clean install dist
 
 all: default
@@ -15,8 +13,30 @@
 docdir      := $(prefix)/share/doc/gbsplay
 localedir   := $(prefix)/share/locale
 
-GBSCFLAGS  := -Wall
-GBSLDFLAGS := -Wl,-O1
+SPLINT := splint
+
+SPLINTFLAGS := \
+	+quiet \
+	-exportlocal \
+	-unrecog \
+	-immediatetrans \
+	-fullinitblock \
+	-namechecks \
+	-preproc \
+	-fcnuse \
+	-predboolint \
+	-boolops \
+	-formatconst \
+	-type \
+	+unixlib \
+	+boolint \
+	+matchanyintegral \
+	+charint \
+	-predboolothers \
+	-shiftnegative \
+	-shiftimplementation
+GBSCFLAGS  := -Wall -fsigned-char -D_FORTIFY_SOURCE=2
+GBSLDFLAGS := -Wl,-O1 -lm
 GBSPLAYLDFLAGS :=
 
 ifneq ($(noincludes),yes)
@@ -48,14 +68,14 @@
 export CC GBSCFLAGS GBSLDFLAGS
 
 docs           := README HISTORY COPYRIGHT
-contribs       := contrib/gbs2ogg.sh
+contribs       := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion
 examples       := examples/nightmode.gbs examples/gbsplayrc_sample
 
 mans           := gbsplay.1    gbsinfo.1    gbsplayrc.5
 mans_src       := gbsplay.in.1 gbsinfo.in.1 gbsplayrc.in.5
 
-objs_libgbspic := gbcpu.lo gbhw.lo gbs.lo cfgparser.lo crc32.lo
-objs_libgbs    := gbcpu.o  gbhw.o  gbs.o  cfgparser.o  crc32.o
+objs_libgbspic := gbcpu.lo gbhw.lo gbs.lo cfgparser.lo crc32.lo impulsegen.lo
+objs_libgbs    := gbcpu.o  gbhw.o  gbs.o  cfgparser.o  crc32.o  impulsegen.o
 objs_gbsplay   := gbsplay.o util.o plugout.o
 objs_gbsinfo   := gbsinfo.o
 objs_gbsxmms   := gbsxmms.lo
@@ -64,12 +84,30 @@
 ifeq ($(plugout_devdsp),yes)
 objs_gbsplay += plugout_devdsp.o
 endif
+ifeq ($(plugout_alsa),yes)
+objs_gbsplay += plugout_alsa.o
+GBSPLAYLDFLAGS += -lasound $(libaudio_flags)
+endif
 ifeq ($(plugout_nas),yes)
 objs_gbsplay += plugout_nas.o
 GBSPLAYLDFLAGS += -laudio $(libaudio_flags)
 endif
 ifeq ($(plugout_stdout),yes)
 objs_gbsplay += plugout_stdout.o
+endif
+ifeq ($(plugout_midi),yes)
+objs_gbsplay += plugout_midi.o
+endif
+
+# install contrib files?
+ifeq ($(build_contrib),yes)
+EXTRA_INSTALL += install-contrib
+EXTRA_UNINSTALL += uninstall-contrib
+endif
+
+# test built binary?
+ifeq ($(build_test),yes)
+TEST_TARGETS += test
 endif
 
 # Cygwin automatically adds .exe to binaries.
@@ -83,10 +121,38 @@
 
 ifeq ($(use_sharedlibgbs),yes)
 GBSLDFLAGS += -L. -lgbs
+objs += $(objs_libgbspic)
+ifeq ($(cygwin_build),yes)
+EXTRA_INSTALL += install-cyggbs-1.dll
+EXTRA_UNINSTALL += uninstall-cyggbs-1.dll
+
+install-cyggbs-1.dll:
+	install -d $(bindir)
+	install -d $(libdir)
+	install -m 644 cyggbs-1.dll $(bindir)/cyggbs-1.dll
+	install -m 644 libgbs.dll.a $(libdir)/libgbs.dll.a
+
+uninstall-cyggbs-1.dll:
+	rm -f $(bindir)/cyggbs-1.dll
+	rm -f $(libdir)/libgbs.dll.a
+	-rmdir -p $(libdir)
+
+
+cyggbs-1.dll: $(objs_libgbspic) libgbs.so.1.ver
+	$(CC) -fpic -shared -Wl,-O1 -Wl,-soname=$@ -Wl,--version-script,libgbs.so.1.ver -o $@ $(objs_libgbspic) $(EXTRA_LDFLAGS)
+
+libgbs.dll.a:
+	dlltool --input-def libgbs.def --dllname cyggbs-1.dll --output-lib libgbs.dll.a -k
+
+libgbs: cyggbs-1.dll libgbs.dll.a
+	touch libgbs
+
+libgbspic: cyggbs-1.dll libgbs.dll.a
+	touch libgbspic
+else
 EXTRA_INSTALL += install-libgbs.so.1
 EXTRA_UNINSTALL += uninstall-libgbs.so.1
 
-objs += $(objs_libgbspic)
 
 install-libgbs.so.1:
 	install -d $(libdir)
@@ -106,6 +172,7 @@
 
 libgbspic: libgbs.so.1
 	touch libgbspic
+endif
 else
 objs += $(objs_libgbs)
 objs_gbsplay += libgbs.a
@@ -133,7 +200,7 @@
 # include the rules for each subdir
 include $(shell find . -type f -name "subdir.mk")
 
-default: config.mk $(objs) $(dsts) $(mans) $(EXTRA_ALL) test
+default: config.mk $(objs) $(dsts) $(mans) $(EXTRA_ALL) $(TEST_TARGETS)
 
 # include the dependency files
 
@@ -161,19 +228,21 @@
 	install -d $(man1dir)
 	install -d $(man5dir)
 	install -d $(docdir)
-	install -d $(contribdir)
 	install -d $(exampledir)
 	install -m 755 $(gbsplaybin) $(gbsinfobin) $(bindir)
 	install -m 644 gbsplay.1 gbsinfo.1 $(man1dir)
 	install -m 644 gbsplayrc.5 $(man5dir)
 	install -m 644 $(docs) $(docdir)
-	install -m 644 $(contribs) $(contribdir)
 	install -m 644 $(examples) $(exampledir)
 	for i in $(mos); do \
 		base=`basename $$i`; \
 		install -d $(localedir)/$${base%.mo}/LC_MESSAGES; \
 		install -m 644 $$i $(localedir)/$${base%.mo}/LC_MESSAGES/gbsplay.mo; \
 	done
+
+install-contrib:
+	install -d $(contribdir)
+	install -m 644 $(contribs) $(contribdir)
 
 install-gbsxmms.so:
 	install -d $(xmmsdir)
@@ -188,8 +257,6 @@
 	-rmdir -p $(man1dir)
 	rm -f $(man5dir)/gbsplayrc.5 $(man5dir)/gbsplayrc.5	
 	-rmdir -p $(man5dir)
-	rm -rf $(contribdir)
-	-rmdir -p $(contribdir)
 	rm -rf $(exampledir)
 	-rmdir -p $(exampledir)
 	rm -rf $(docdir)
@@ -200,6 +267,10 @@
 		rm -f $(localedir)/$${base%.mo}/LC_MESSAGES/gbsplay.mo; \
 		rmdir -p $(localedir)/$${base%.mo}/LC_MESSAGES; \
 	done
+
+uninstall-contrib:
+	rm -rf $(contribdir)
+	-rmdir -p $(contribdir)
 
 uninstall-gbsxmms.so:
 	rm -f $(xmmsdir)/gbsxmms.so
@@ -230,7 +301,7 @@
 
 test: gbsplay
 	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -E b -o stdout $(TESTOPTS) examples/nightmode.gbs 1 | md5sum | cut -f1 -d\ `; \
-	EXPECT="3e0b21573e742101581b503da3ddf2f5"; \
+	EXPECT="577ade576a9b99de27edff4236c8e303"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Bigendian output ok"; \
 	else \
@@ -240,7 +311,7 @@
 		exit 1; \
 	fi
 	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -E l -o stdout $(TESTOPTS) examples/nightmode.gbs 1 | md5sum | cut -f1 -d\ `; \
-	EXPECT="3e540a0bddc00cb1e0b7c4bf1a3708d7"; \
+	EXPECT="4423ba04ce18f5328986b5595991129c"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Littleendian output ok"; \
 	else \
@@ -271,6 +342,7 @@
 	@$(CC) $(GBSCFLAGS) -fpic -c -o $@ $<
 .c.o:
 	@echo CC $< -o $@
+	@(test -x "`which $(SPLINT)`" && $(SPLINT) $(SPLINTFLAGS) $<) || true
 	@$(CC) $(GBSCFLAGS) -c -o $@ $<
 .c.i:
 	$(CC) -E $(GBSCFLAGS) -o $@ $<
