## gbsplay 0.0.93

=== Makefile ===
--- 
+++ 
@@ -65,9 +65,10 @@
 GBSCFLAGS  += $(EXTRA_CFLAGS)
 GBSLDFLAGS += $(EXTRA_LDFLAGS)
 
-export CC GBSCFLAGS GBSLDFLAGS
+export CC HOSTCC BUILDCC GBSCFLAGS GBSLDFLAGS
 
 docs           := README HISTORY COPYRIGHT
+docs-dist      := INSTALL CODINGSTYLE TESTSUITE gbsformat.txt
 contribs       := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion
 examples       := examples/nightmode.gbs examples/gbsplayrc_sample
 
@@ -79,6 +80,9 @@
 objs_gbsplay   := gbsplay.o util.o plugout.o
 objs_gbsinfo   := gbsinfo.o
 objs_gbsxmms   := gbsxmms.lo
+objs_test_gbs  := test_gbs.o
+
+tests          := util.test
 
 # gbsplay output plugins
 ifeq ($(plugout_devdsp),yes)
@@ -97,6 +101,14 @@
 endif
 ifeq ($(plugout_midi),yes)
 objs_gbsplay += plugout_midi.o
+endif
+ifeq ($(plugout_pulse),yes)
+objs_gbsplay += plugout_pulse.o
+GBSPLAYLDFLAGS += -lpulse-simple -lpulse
+endif
+ifeq ($(plugout_dsound),yes)
+objs_gbsplay += plugout_dsound.o
+GBSPLAYLDFLAGS += -ldsound $(libdsound_flags)
 endif
 
 # install contrib files?
@@ -114,9 +126,13 @@
 # We should notice that or we can't rm the files later!
 gbsplaybin     := gbsplay
 gbsinfobin     := gbsinfo
+test_gbsbin    := test_gbs
+test_bin       := test
 ifeq ($(cygwin_build),yes)
 gbsplaybin     :=$(gbsplaybin).exe
 gbsinfobin     :=$(gbsinfobin).exe
+test_gbsbin    :=$(test_gbsbin).exe
+test_bin       :=$(test).exe
 endif
 
 ifeq ($(use_sharedlibgbs),yes)
@@ -164,7 +180,7 @@
 
 
 libgbs.so.1: $(objs_libgbspic) libgbs.so.1.ver
-	$(CC) -fpic -shared -Wl,-O1 -Wl,-soname=$@ -Wl,--version-script,$@.ver -o $@ $(objs_libgbspic)
+	$(BUILDCC) -fpic -shared -Wl,-O1 -Wl,-soname=$@ -Wl,--version-script,$@.ver -o $@ $(objs_libgbspic)
 	ln -fs $@ libgbs.so
 
 libgbs: libgbs.so.1
@@ -177,6 +193,7 @@
 objs += $(objs_libgbs)
 objs_gbsplay += libgbs.a
 objs_gbsinfo += libgbs.a
+objs_test_gbs += libgbs.a
 ifeq ($(build_xmmsplugin),yes)
 objs += $(objs_libgbspic)
 objs_gbsxmms += libgbspic.a
@@ -220,6 +237,7 @@
 	rm -f libgbs libgbspic
 	rm -f $(mans)
 	rm -f $(gbsplaybin) $(gbsinfobin)
+	rm -f $(test_gbsbin) $(test_bin)
 
 install: all install-default $(EXTRA_INSTALL)
 
@@ -255,7 +273,7 @@
 	-rmdir -p $(bindir)
 	rm -f $(man1dir)/gbsplay.1 $(man1dir)/gbsinfo.1
 	-rmdir -p $(man1dir)
-	rm -f $(man5dir)/gbsplayrc.5 $(man5dir)/gbsplayrc.5	
+	rm -f $(man5dir)/gbsplayrc.5
 	-rmdir -p $(man5dir)
 	rm -rf $(exampledir)
 	-rmdir -p $(exampledir)
@@ -284,9 +302,9 @@
 	install -m 644 Makefile ./$(DISTDIR)/
 	install -m 644 *.c ./$(DISTDIR)/
 	install -m 644 *.h ./$(DISTDIR)/
-	install -m 644 *.ver ./$(DISTDIR)/
+	install -m 644 *.ver *.def ./$(DISTDIR)/
 	install -m 644 $(mans_src) ./$(DISTDIR)/
-	install -m 644 $(docs) INSTALL CODINGSTYLE ./$(DISTDIR)/
+	install -m 644 $(docs) $(docs-dist) ./$(DISTDIR)/
 	install -d ./$(DISTDIR)/examples
 	install -m 644 $(examples) ./$(DISTDIR)/examples
 	install -d ./$(DISTDIR)/contrib
@@ -294,14 +312,16 @@
 	install -d ./$(DISTDIR)/po
 	install -m 644 po/*.po ./$(DISTDIR)/po
 	install -m 644 po/subdir.mk ./$(DISTDIR)/po
+	install -m 644 .gitignore ./$(DISTDIR)/
 	tar -cvzf ../$(DISTDIR).tar.gz $(DISTDIR)/ 
 	rm -rf ./$(DISTDIR)
 
 TESTOPTS := -r 44100 -t 30 -f 0 -g 0 -T 0
 
-test: gbsplay
-	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -E b -o stdout $(TESTOPTS) examples/nightmode.gbs 1 | md5sum | cut -f1 -d\ `; \
-	EXPECT="577ade576a9b99de27edff4236c8e303"; \
+test: gbsplay $(tests) test_gbs
+	@echo Verifying output correctness for examples/nightmode.gbs:
+	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E b -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | md5sum | cut -f1 -d\ `; \
+	EXPECT="5269fdada196a6b67d947428ea3ca934"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Bigendian output ok"; \
 	else \
@@ -310,8 +330,8 @@
 		echo "  Got:      $$MD5" ; \
 		exit 1; \
 	fi
-	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -E l -o stdout $(TESTOPTS) examples/nightmode.gbs 1 | md5sum | cut -f1 -d\ `; \
-	EXPECT="4423ba04ce18f5328986b5595991129c"; \
+	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E l -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | md5sum | cut -f1 -d\ `; \
+	EXPECT="3c005a70135621d8eb3e0dc20982eba8"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Littleendian output ok"; \
 	else \
@@ -326,12 +346,14 @@
 libgbs.a: $(objs_libgbs)
 	$(AR) r $@ $+
 gbsinfo: $(objs_gbsinfo) libgbs
-	$(CC) -o $(gbsinfobin) $(objs_gbsinfo) $(GBSLDFLAGS)
+	$(BUILDCC) -o $(gbsinfobin) $(objs_gbsinfo) $(GBSLDFLAGS)
 gbsplay: $(objs_gbsplay) libgbs
-	$(CC) -o $(gbsplaybin) $(objs_gbsplay) $(GBSLDFLAGS) $(GBSPLAYLDFLAGS) -lm
+	$(BUILDCC) -o $(gbsplaybin) $(objs_gbsplay) $(GBSLDFLAGS) $(GBSPLAYLDFLAGS) -lm
+test_gbs: $(objs_test_gbs) libgbs
+	$(BUILDCC) -o $(test_gbsbin) $(objs_test_gbs) $(GBSLDFLAGS)
 
 gbsxmms.so: $(objs_gbsxmms) libgbspic gbsxmms.so.ver
-	$(CC) -shared -fpic -Wl,--version-script,$@.ver -o $@ $(objs_gbsxmms) $(GBSLDFLAGS) $(PTHREAD)
+	$(BUILDCC) -shared -fpic -Wl,--version-script,$@.ver -o $@ $(objs_gbsxmms) $(GBSLDFLAGS) $(PTHREAD)
 
 # rules for suffixes
 
@@ -339,20 +361,27 @@
 
 .c.lo:
 	@echo CC $< -o $@
-	@$(CC) $(GBSCFLAGS) -fpic -c -o $@ $<
+	@$(BUILDCC) $(GBSCFLAGS) -fpic -c -o $@ $<
 .c.o:
 	@echo CC $< -o $@
 	@(test -x "`which $(SPLINT)`" && $(SPLINT) $(SPLINTFLAGS) $<) || true
-	@$(CC) $(GBSCFLAGS) -c -o $@ $<
+	@$(BUILDCC) $(GBSCFLAGS) -c -o $@ $<
+
 .c.i:
-	$(CC) -E $(GBSCFLAGS) -o $@ $<
+	$(BUILDCC) -E $(GBSCFLAGS) -o $@ $<
 .c.s:
-	$(CC) -S $(GBSCFLAGS) -fverbose-asm -o $@ $<
+	$(BUILDCC) -S $(GBSCFLAGS) -fverbose-asm -o $@ $<
 
 # rules for generated files
 
 config.mk: configure
 	./configure
+
+%.test: %.c
+	@echo -n "TEST $< "
+	@$(HOSTCC) -DENABLE_TEST=1 -o $(test_bin) $<
+	@./$(test_bin)
+	@rm ./$(test_bin)
 
 %.d: %.c config.mk
 	@echo DEP $< -o $@
