=== debian/changelog ===
gbsplay (0.0.93-3) unstable; urgency=medium

  * Bump standards version to 4.1.3.
  * Bump debhelper version to 11.
  * debian/source/format: added.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 05 Jan 2018 14:48:03 +0100

gbsplay (0.0.93-2) unstable; urgency=medium

  * Update my name.
  * Apply ESTRPIPE patch to fix a bug. (Closes: #815490)
  * Bump standards version to 3.9.8.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 23 Jan 2017 15:49:28 +0100

gbsplay (0.0.93-1) unstable; urgency=medium

  * New upstream release (Closes: #794618).
  * Update debian/copyright:
    - List original copyright instead of boilerplate GPL-2 licence text.
    - Link to /usr/share/common-licenses/GPL-1 as unversioned GPL means
      "choose any" (v1 or later).  This fixes the lintian warning
      copyright-refers-to-versionless-license-file
  * Update debian/rules to fix lintian warnings:
    - hardening-no-relro

 -- Christian Garbs <debian@cgarbs.de>  Sun, 30 Aug 2015 20:33:29 +0200

gbsplay (0.0.92-1) unstable; urgency=medium

  * New upstream release (Closes: #715944, #777862).
  * Ship contrib/gbs2ogg.sh again, license is now provided.
  * Update debian/rules to fix lintian warnings:
    - debian-rules-missing-recommended-target
    - dh-clean-k-is-deprecated
    - description-synopsis-starts-with-article
    - ancient-standards-version (no changes)
  * Update Debian compat version to 9.
  * Add debian/watch.

 -- Christian Garbs <debian@cgarbs.de>  Sun, 02 Aug 2015 14:55:37 +0200

gbsplay (0.0.91-1) unstable; urgency=low

  * New upstream version.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Tue, 19 Aug 2008 17:30:19 +0200

gbsplay (0.0.9+dfsg1-1) unstable; urgency=low

  * New upstream version.
  * Updated my email address.
  * Updated standards version.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Tue, 08 Jul 2008 12:55:56 +0200

gbsplay (0.0.8+dfsg1-3) unstable; urgency=low

  * Remove build-depends on xmms-dev and don't build the xmms
    plugin anymore. (Closes: #456741)
  * Bump standards version.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Sat, 12 Jan 2008 12:57:40 +0100

gbsplay (0.0.8+dfsg1-2) unstable; urgency=low

  * Turned off buggy endian checks. (Closes: #418726)

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Wed, 09 May 2007 10:27:07 +0200

gbsplay (0.0.8+dfsg1-1) unstable; urgency=low

  * Initial release. (Closes: #411445)
  * Rebuilt the tarball (non-free contrib script).

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Mon, 19 Feb 2007 08:49:34 +0100
