## gbsplay 0.0.94

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,20 @@
 .PHONY: all default distclean clean install dist
 
+ifeq ("$(origin V)", "command line")
+  VERBOSE = $(V)
+endif
+ifndef VERBOSE
+  VERBOSE = 0
+endif
+ifeq ($(VERBOSE),1)
+  Q =
+else
+  Q = @
+endif
+
 all: default
 
-noincludes  := $(patsubst clean,yes,$(patsubst distclean,yes,$(MAKECMDGOALS)))
+noincludes  := $(patsubst distclean,yes,$(MAKECMDGOALS))
 
 prefix      := /usr/local
 exec_prefix := $(prefix)
@@ -12,6 +24,8 @@
 mandir      := $(prefix)/man
 docdir      := $(prefix)/share/doc/gbsplay
 localedir   := $(prefix)/share/locale
+mimedir     := $(prefix)/share/mime
+appdir      := $(prefix)/share/applications
 
 SPLINT := splint
 
@@ -35,9 +49,6 @@
 	-predboolothers \
 	-shiftnegative \
 	-shiftimplementation
-GBSCFLAGS  := -Wall -fsigned-char -D_FORTIFY_SOURCE=2
-GBSLDFLAGS := -Wl,-O1 -lm
-GBSPLAYLDFLAGS :=
 
 ifneq ($(noincludes),yes)
 -include config.mk
@@ -52,6 +63,8 @@
 mandir      := $(DESTDIR)$(mandir)
 docdir      := $(DESTDIR)$(docdir)
 localedir   := $(DESTDIR)$(localedir)
+mimedir     := $(DESTDIR)$(mimedir)
+appdir      := $(DESTDIR)$(appdir)
 
 xmmsdir     := $(DESTDIR)$(XMMSPREFIX)$(XMMS_INPUT_PLUGIN_DIR)
 
@@ -62,27 +75,30 @@
 
 DISTDIR := gbsplay-$(VERSION)
 
-GBSCFLAGS  += $(EXTRA_CFLAGS)
-GBSLDFLAGS += $(EXTRA_LDFLAGS)
-
-export CC HOSTCC BUILDCC GBSCFLAGS GBSLDFLAGS
-
-docs           := README HISTORY COPYRIGHT
-docs-dist      := INSTALL CODINGSTYLE TESTSUITE gbsformat.txt
-contribs       := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion
-examples       := examples/nightmode.gbs examples/gbsplayrc_sample
-
-mans           := gbsplay.1    gbsinfo.1    gbsplayrc.5
-mans_src       := gbsplay.in.1 gbsinfo.in.1 gbsplayrc.in.5
-
-objs_libgbspic := gbcpu.lo gbhw.lo gbs.lo cfgparser.lo crc32.lo impulsegen.lo
-objs_libgbs    := gbcpu.o  gbhw.o  gbs.o  cfgparser.o  crc32.o  impulsegen.o
-objs_gbsplay   := gbsplay.o util.o plugout.o
-objs_gbsinfo   := gbsinfo.o
-objs_gbsxmms   := gbsxmms.lo
-objs_test_gbs  := test_gbs.o
-
-tests          := util.test
+GBSCFLAGS  := $(EXTRA_CFLAGS)
+GBSLDFLAGS := $(EXTRA_LDFLAGS)
+# Additional ldflags for the gbsplay executable
+GBSPLAYLDFLAGS :=
+
+export Q VERBOSE CC HOSTCC BUILDCC GBSCFLAGS GBSLDFLAGS
+
+docs               := README HISTORY COPYRIGHT
+docs-dist          := INSTALL CODINGSTYLE TESTSUITE gbsformat.txt
+contribs           := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion
+examples           := examples/nightmode.gbs examples/gbsplayrc_sample
+
+mans               := man/gbsplay.1    man/gbsinfo.1    man/gbsplayrc.5
+mans_src           := man/gbsplay.in.1 man/gbsinfo.in.1 man/gbsplayrc.in.5
+
+objs_libgbspic     := gbcpu.lo gbhw.lo gbs.lo cfgparser.lo crc32.lo
+objs_libgbs        := gbcpu.o  gbhw.o  gbs.o  cfgparser.o  crc32.o
+objs_gbsplay       := gbsplay.o util.o plugout.o
+objs_gbsinfo       := gbsinfo.o
+objs_gbsxmms       := gbsxmms.lo
+objs_test_gbs      := test_gbs.o
+objs_gen_impulse_h := gen_impulse_h.ho impulsegen.ho
+
+tests              := util.test impulsegen.test
 
 # gbsplay output plugins
 ifeq ($(plugout_devdsp),yes)
@@ -102,6 +118,9 @@
 ifeq ($(plugout_midi),yes)
 objs_gbsplay += plugout_midi.o
 endif
+ifeq ($(plugout_altmidi),yes)
+objs_gbsplay += plugout_altmidi.o
+endif
 ifeq ($(plugout_pulse),yes)
 objs_gbsplay += plugout_pulse.o
 GBSPLAYLDFLAGS += -lpulse-simple -lpulse
@@ -109,6 +128,9 @@
 ifeq ($(plugout_dsound),yes)
 objs_gbsplay += plugout_dsound.o
 GBSPLAYLDFLAGS += -ldsound $(libdsound_flags)
+endif
+ifeq ($(plugout_iodumper),yes)
+objs_gbsplay += plugout_iodumper.o
 endif
 
 # install contrib files?
@@ -124,20 +146,26 @@
 
 # Cygwin automatically adds .exe to binaries.
 # We should notice that or we can't rm the files later!
-gbsplaybin     := gbsplay
-gbsinfobin     := gbsinfo
-test_gbsbin    := test_gbs
-test_bin       := test
 ifeq ($(cygwin_build),yes)
-gbsplaybin     :=$(gbsplaybin).exe
-gbsinfobin     :=$(gbsinfobin).exe
-test_gbsbin    :=$(test_gbsbin).exe
-test_bin       :=$(test).exe
-endif
+binsuffix         := .exe
+else
+binsuffix         :=
+endif
+gbsplaybin        := gbsplay$(binsuffix)
+gbsinfobin        := gbsinfo$(binsuffix)
+test_gbsbin       := test_gbs$(binsuffix)
+gen_impulse_h_bin := gen_impulse_h$(binsuffix)
 
 ifeq ($(use_sharedlibgbs),yes)
 GBSLDFLAGS += -L. -lgbs
 objs += $(objs_libgbspic)
+
+libgbs.so.1.ver: libgbs_whitelist.txt gen_linkercfg.sh
+	./gen_linkercfg.sh libgbs_whitelist.txt $@ ver
+
+libgbs.def: libgbs_whitelist.txt gen_linkercfg.sh
+	./gen_linkercfg.sh libgbs_whitelist.txt $@ def
+
 ifeq ($(cygwin_build),yes)
 EXTRA_INSTALL += install-cyggbs-1.dll
 EXTRA_UNINSTALL += uninstall-cyggbs-1.dll
@@ -153,11 +181,10 @@
 	rm -f $(libdir)/libgbs.dll.a
 	-rmdir -p $(libdir)
 
-
 cyggbs-1.dll: $(objs_libgbspic) libgbs.so.1.ver
-	$(CC) -fpic -shared -Wl,-O1 -Wl,-soname=$@ -Wl,--version-script,libgbs.so.1.ver -o $@ $(objs_libgbspic) $(EXTRA_LDFLAGS)
-
-libgbs.dll.a:
+	$(CC) -fpic -shared -Wl,-soname=$@ -Wl,--version-script,libgbs.so.1.ver -o $@ $(objs_libgbspic) $(EXTRA_LDFLAGS)
+
+libgbs.dll.a: libgbs.def
 	dlltool --input-def libgbs.def --dllname cyggbs-1.dll --output-lib libgbs.dll.a -k
 
 libgbs: cyggbs-1.dll libgbs.dll.a
@@ -180,7 +207,7 @@
 
 
 libgbs.so.1: $(objs_libgbspic) libgbs.so.1.ver
-	$(BUILDCC) -fpic -shared -Wl,-O1 -Wl,-soname=$@ -Wl,--version-script,$@.ver -o $@ $(objs_libgbspic)
+	$(BUILDCC) -fpic -shared -Wl,-soname=$@ -Wl,--version-script,$@.ver -o $@ $(objs_libgbspic) -lm
 	ln -fs $@ libgbs.so
 
 libgbs: libgbs.so.1
@@ -190,6 +217,7 @@
 	touch libgbspic
 endif
 else
+GBSLDFLAGS += -lm
 objs += $(objs_libgbs)
 objs_gbsplay += libgbs.a
 objs_gbsinfo += libgbs.a
@@ -232,12 +260,13 @@
 	rm -f ./config.mk ./config.h ./config.err ./config.sed
 
 clean:
-	find . -regex ".*\.\([aos]\|lo\|mo\|pot\|so\(\.[0-9]\)?\)" -exec rm -f "{}" \;
+	find . -regex ".*\.\([aos]\|ho\|lo\|mo\|pot\|test\(\.exe\)?\|so\(\.[0-9]\)?\)" -exec rm -f "{}" \;
 	find . -name "*~" -exec rm -f "{}" \;
-	rm -f libgbs libgbspic
+	rm -f libgbs libgbspic libgbs.def libgbs.so.1.ver
 	rm -f $(mans)
 	rm -f $(gbsplaybin) $(gbsinfobin)
-	rm -f $(test_gbsbin) $(test_bin)
+	rm -f $(test_gbsbin)
+	rm -f $(gen_impulse_h_bin) impulse.h
 
 install: all install-default $(EXTRA_INSTALL)
 
@@ -247,9 +276,15 @@
 	install -d $(man5dir)
 	install -d $(docdir)
 	install -d $(exampledir)
+	install -d $(mimedir)/packages
+	install -d $(appdir)
 	install -m 755 $(gbsplaybin) $(gbsinfobin) $(bindir)
-	install -m 644 gbsplay.1 gbsinfo.1 $(man1dir)
-	install -m 644 gbsplayrc.5 $(man5dir)
+	install -m 644 man/gbsplay.1 man/gbsinfo.1 $(man1dir)
+	install -m 644 man/gbsplayrc.5 $(man5dir)
+	install -m 644 mime/gbsplay.xml $(mimedir)/packages
+	-update-mime-database $(mimedir)
+	install -m 644 desktop/gbsplay.desktop $(appdir)
+	-update-desktop-database $(appdir)
 	install -m 644 $(docs) $(docdir)
 	install -m 644 $(examples) $(exampledir)
 	for i in $(mos); do \
@@ -275,6 +310,12 @@
 	-rmdir -p $(man1dir)
 	rm -f $(man5dir)/gbsplayrc.5
 	-rmdir -p $(man5dir)
+	rm -f $(mimedir)/packages/gbsplay.xml
+	-update-mime-database $(mimedir)
+	-rmdir -p $(mimedir)/packages
+	rm -f $(appdir)/gbsplay.desktop
+	-update-desktop-database $(appdir)
+	-rmdir -p $(appdir)
 	rm -rf $(exampledir)
 	-rmdir -p $(exampledir)
 	rm -rf $(docdir)
@@ -302,8 +343,9 @@
 	install -m 644 Makefile ./$(DISTDIR)/
 	install -m 644 *.c ./$(DISTDIR)/
 	install -m 644 *.h ./$(DISTDIR)/
-	install -m 644 *.ver *.def ./$(DISTDIR)/
-	install -m 644 $(mans_src) ./$(DISTDIR)/
+	install -m 644 *.ver ./$(DISTDIR)/
+	install -d ./$(DISTDIR)/man
+	install -m 644 $(mans_src) ./$(DISTDIR)/man
 	install -m 644 $(docs) $(docs-dist) ./$(DISTDIR)/
 	install -d ./$(DISTDIR)/examples
 	install -m 644 $(examples) ./$(DISTDIR)/examples
@@ -313,15 +355,19 @@
 	install -m 644 po/*.po ./$(DISTDIR)/po
 	install -m 644 po/subdir.mk ./$(DISTDIR)/po
 	install -m 644 .gitignore ./$(DISTDIR)/
+	install -d ./$(DISTDIR)/mime
+	install -m 644 mime/* ./$(DISTDIR)/mime
+	install -d ./$(DISTDIR)/desktop
+	install -m 644 desktop/* ./$(DISTDIR)/desktop
 	tar -cvzf ../$(DISTDIR).tar.gz $(DISTDIR)/ 
 	rm -rf ./$(DISTDIR)
 
-TESTOPTS := -r 44100 -t 30 -f 0 -g 0 -T 0
+TESTOPTS := -r 44100 -t 30 -f 0 -g 0 -T 0 -H off
 
 test: gbsplay $(tests) test_gbs
 	@echo Verifying output correctness for examples/nightmode.gbs:
-	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E b -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | md5sum | cut -f1 -d\ `; \
-	EXPECT="5269fdada196a6b67d947428ea3ca934"; \
+	$(Q)MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E b -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | (md5sum || md5 -r) | cut -f1 -d\ `; \
+	EXPECT="a6f920f9a9ac2bfbd0c7e22bb740db1c"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Bigendian output ok"; \
 	else \
@@ -330,8 +376,8 @@
 		echo "  Got:      $$MD5" ; \
 		exit 1; \
 	fi
-	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E l -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | md5sum | cut -f1 -d\ `; \
-	EXPECT="3c005a70135621d8eb3e0dc20982eba8"; \
+	$(Q)MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E l -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | (md5sum || md5 -r) | cut -f1 -d\ `; \
+	EXPECT="c82104c3a25fe794df1496d66d9cf24c"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Littleendian output ok"; \
 	else \
@@ -340,6 +386,13 @@
 		echo "  Got:      $$MD5" ; \
 		exit 1; \
 	fi
+
+$(gen_impulse_h_bin): $(objs_gen_impulse_h)
+	$(HOSTCC) -o $(gen_impulse_h_bin) $(objs_gen_impulse_h) -lm
+impulse.h: $(gen_impulse_h_bin)
+	$(Q)./$(gen_impulse_h_bin) > $@
+gbhw.o: impulse.h
+gbhw.lo: impulse.h
 
 libgbspic.a: $(objs_libgbspic)
 	$(AR) r $@ $+
@@ -357,15 +410,18 @@
 
 # rules for suffixes
 
-.SUFFIXES: .i .s .lo
+.SUFFIXES: .i .s .lo .ho
 
 .c.lo:
 	@echo CC $< -o $@
-	@$(BUILDCC) $(GBSCFLAGS) -fpic -c -o $@ $<
+	$(Q)$(BUILDCC) $(GBSCFLAGS) -fpic -c -o $@ $<
 .c.o:
 	@echo CC $< -o $@
-	@(test -x "`which $(SPLINT)`" && $(SPLINT) $(SPLINTFLAGS) $<) || true
-	@$(BUILDCC) $(GBSCFLAGS) -c -o $@ $<
+	$(Q)(test -x "`which $(SPLINT)`" && $(SPLINT) $(SPLINTFLAGS) $<) || true
+	$(Q)$(BUILDCC) $(GBSCFLAGS) -fpie -c -o $@ $<
+.c.ho:
+	@echo HOSTCC $< -o $@
+	$(Q)$(HOSTCC) $(GBSCFLAGS) -fpie -c -o $@ $<
 
 .c.i:
 	$(BUILDCC) -E $(GBSCFLAGS) -o $@ $<
@@ -378,17 +434,12 @@
 	./configure
 
 %.test: %.c
-	@echo -n "TEST $< "
-	@$(HOSTCC) -DENABLE_TEST=1 -o $(test_bin) $<
-	@./$(test_bin)
-	@rm ./$(test_bin)
+	@echo TEST $<
+	$(Q)$(HOSTCC) -DENABLE_TEST=1 -o $@$(binsuffix) $< -lm
+	$(Q)./$@$(binsuffix)
+	$(Q)rm ./$@$(binsuffix)
 
 %.d: %.c config.mk
 	@echo DEP $< -o $@
-	@./depend.sh $< config.mk > $@ || rm -f $@
-
-%.1: %.in.1
-	sed -f config.sed $< > $@
-
-%.5: %.in.5
-	sed -f config.sed $< > $@
+	$(Q)./depend.sh $< config.mk > $@ || rm -f $@
+
