=== debian/changelog ===
gbsplay (0.0.94-2) unstable; urgency=medium

  * Disable tests due failure, reported upstream.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 20 Jan 2021 05:11:04 +0100

gbsplay (0.0.94-1) unstable; urgency=medium

  * New upstream version.
  * debian/gbsplay.desktop: Added.
  * Bump standards version to 4.5.0.
  * Bump debhelper version to 13, drop d/compat.
  * d/upstream/metadata: added.
  * d/control: added Rules-Requires-Root.
  * d/rules: modernized.
  * d/copyright: modernized.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 03 Jul 2020 22:24:10 +0200
