=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
 Uploaders: Christian Garbs <debian@cgarbs.de>
-Standards-Version: 4.1.3
-Build-Depends: debhelper (>= 11), gettext, libaudio-dev, libpulse-dev, libasound2-dev
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 13), gettext, libaudio-dev, libpulse-dev, libasound2-dev
 Homepage: https://github.com/mmitch/gbsplay
 
 Package: gbsplay
