=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -W

override_dh_auto_configure:
	./configure \
	--prefix=/usr \
	--exec-prefix=/usr \
	--mandir=\$${prefix}/share/man \
	--sysconfdir=/etc \
	--datadir=\$${prefix}/share/gbsplay \
	--bindir=\$${prefix}/bin \
	--infodir=\$${prefix}/share/info \
	--enable-nas --enable-midi --enable-devdsp --enable-stdout --enable-alsa --enable-pulse --without-xmmsplugin \
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	dh_auto_install
	-rm -r debian/gbsplay/usr/share/mime/aliases debian/gbsplay/usr/share/mime/generic-icons debian/gbsplay/usr/share/mime/globs debian/gbsplay/usr/share/mime/globs2 debian/gbsplay/usr/share/mime/icons debian/gbsplay/usr/share/mime/magic debian/gbsplay/usr/share/mime/mime.cache debian/gbsplay/usr/share/mime/subclasses debian/gbsplay/usr/share/mime/treemagic debian/gbsplay/usr/share/mime/types debian/gbsplay/usr/share/mime/version debian/gbsplay/usr/share/mime/XMLnamespaces debian/gbsplay/usr/share/mime/audio debian/gbsplay/usr/share/applications/*.cache

override_dh_auto_test:
	@echo SKIPPING TESTS, SEE https://github.com/mmitch/gbsplay/issues/62

%:
	dh $@ --no-parallel
